#ifndef production
static char rcsId[]="$Header$";
#endif
/*****
* wchar.c : XmHTML wide character string functions
*
* This file Version	$Revision$
*
* Creation date:		Sun Aug  9 22:33:11 CEST 1998
* Last modification: 	$Date$
* By:					$Author$
* Current State:		$State$
*
* Author:				XmHTML Developers Account
*
* Copyright (C) 1994-1998 by Ripley Software Development 
* All Rights Reserved
*
* This file is part of the XmHTML Widget Library
*
* This library is free software; you can redistribute it and/or
* modify it under the terms of the GNU Library General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Library General Public License for more details.
*
* You should have received a copy of the GNU Library General Public
* License along with this library; if not, write to the Free
* Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*****/
/*****
* ChangeLog 
* $Log$
*****/ 
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef WITH_DMALLOC
#include <dmalloc.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*** External Function Prototype Declarations ***/

/*** Public Variable Declarations ***/

/*** Private Datatype Declarations ****/
#ifdef UNICODE
typedef unsigned short Byte;
#else
typedef unsigned char Byte;
#endif

/*** Private Function Prototype Declarations ****/

/*** Private Variable Declarations ***/

/* strdup for array of Byte's */
Byte*
wchar_strndup(const Byte *cur, int len)
{
	Byte *ret = malloc((len + 1) * sizeof(Byte));

	if(ret == NULL)
	{
		fprintf(stderr, "malloc of %d byte failed\n", (len + 1) * sizeof(Byte));
		return(NULL);
	}
	memcpy(ret, cur, len * sizeof(Byte));
	ret[len] = 0;
	return(ret);
}

/* strdup for Byte's */
Byte*
wchar_strdup(const Byte *cur)
{
	const Byte *p = cur;

	while(IS_Byte(*p))
		p++;

	return(Strndup(cur, p - cur));
}

/* strcmp for Byte's */
int
wchar_strcmp(const Byte *str1, const Byte *str2)
{
	register int tmp;
	do
	{
		tmp = *str1++ - *str2++;
		if(tmp != 0)
			return(tmp);
	}while ((*str1 != 0) && (*str2 != 0));
	return(*str1 - *str2);
}

/* strncmp for Byte's */
int
wchar_strncmp(const Byte *str1, const Byte *str2, int len)
{
	register int tmp;

	if(len <= 0)
		return(0);
	do
	{
		tmp = *str1++ - *str2++;
		if (tmp != 0)
			return(tmp);
		len--;
		if (len <= 0)
			return(0);
	}while((*str1 != 0) && (*str2 != 0));

	return(*str1 - *str2);
}

/* strchr for Byte's */
Byte*
wchar_strchr(const Byte *str, Byte val)
{
	while(*str != 0)
	{
		if(*str == val)
			return((Byte *)str);
		str++;
	}
	return(NULL);
}
